#ifndef _GCODE_STRUCT_H
#define _GCODE_STRUCT_H

#include <stdint.h>

/// Structure for holding GCODE fileline data
typedef struct
{
	char gcode_fileline[100];
	char valid[10];

	char g_char[3];
	char m_char[3];
	char t_char[1];
	char s_char[5];
	char p_char[5];
	char x_char[9];
	char y_char[8];
	char z_char[8];
	char e_char[8];
	char f_char[8];
 
	uint8_t g_num;
	uint8_t m_num;
	uint8_t t_num;
	uint16_t s_num;
	uint16_t p_num;
	double x_num;
	double y_num;
	double z_num;
	double e_num;
	double f_num;

	double x_travel;
	double y_travel;
	double z_travel;
	double e_travel;

	uint8_t x_dir; 
	uint32_t x_start_stop_speed;
	uint32_t x_total_steps;
	uint32_t x_ramp_up_steps;
	uint32_t x_running_steps;
	uint32_t x_ramp_down_steps;
	uint32_t x_ramp_inc_dec;

	uint8_t y_dir;
	uint32_t y_start_stop_speed;
	uint32_t y_total_steps;
	uint32_t y_ramp_up_steps;
	uint32_t y_running_steps;
	uint32_t y_ramp_down_steps;
	uint32_t y_ramp_inc_dec;

	uint8_t z_dir;
	uint32_t z_start_stop_speed;
	uint32_t z_total_steps;
	uint32_t z_ramp_up_steps;
	uint32_t z_running_steps;
	uint32_t z_ramp_down_steps;
	uint32_t z_ramp_inc_dec;

	uint8_t e_dir;
	uint32_t e_start_stop_speed;
	uint32_t e_total_steps;
	uint32_t e_ramp_up_steps;
	uint32_t e_running_steps;
	uint32_t e_ramp_down_steps;
	uint32_t e_ramp_inc_dec;

} GCODE_STRUCT;

/// Structures for holding the current and
/// previous GCODE fileline data.
extern volatile GCODE_STRUCT current_gcode;
extern GCODE_STRUCT previous_gcode;

#endif /* _GCODE_STRUCT_H */